//
// PeerPageConfiguration.cs
//
// Author:
//       Carsten Sonne Larsen <cs@innolan.dk>
//
// Copyright (c) 2013-2016 Carsten Sonne Larsen
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

using System;
using System.Collections.Generic;
using System.Globalization;
using Ntp.Analyzer.Config.Destination;
using Ntp.Analyzer.Config.Graph;
using Ntp.Analyzer.Config.Navigation;
using Ntp.Analyzer.Localize;
using Ntp.Config;

namespace Ntp.Analyzer.Config.Page
{
    public sealed class PeerPageConfiguration : PageConfigurationBase, ILinkable
    {
        private PeerPageConfiguration(
            HostConfiguration server,
            string configName,
            int indentLevel,
            int frequency,
            bool initialRun,
            bool fixedRun,
            string theme,
            string title,
            IEnumerable<GraphSetConfiguration> graphs,
            DestinationCollection destinations,
            string link)
            : base(
                server,
                configName,
                indentLevel,
                frequency,
                initialRun,
                fixedRun,
                theme,
                title,
                destinations,
                link)
        {
            this.graphs = new List<GraphSetConfiguration>(graphs);
            graphPages = new List<PeerGraphPageConfiguration>();
        }

        public const string Identifier = ConfigurationKeyword.PeerPages;

        private new const bool DefaultInitialRun = true;
        private new const bool DefaultFixedRun = true;
        private const int DefaultFrequency = 240;

        private static readonly String[] Params =
        {
            ConfigurationKeyword.PeerPages,
            ConfigurationKeyword.Frequency,
            ConfigurationKeyword.InitialRun,
            ConfigurationKeyword.FixedRun,
            ConfigurationKeyword.PageTemplate,
            ConfigurationKeyword.PageTitle,
            GraphSetConfiguration.Identifier,
            DirectoryCollection.Identifier,
            ConfigurationKeyword.PageLink
        };

        private readonly List<PeerGraphPageConfiguration> graphPages;
        private readonly List<GraphSetConfiguration> graphs;

        /// <summary>
        /// Gets the graphs to be displayed on this page.
        /// </summary>
        /// <value>The peer graphs.</value>
        public IEnumerable<GraphSetConfiguration> Graphs
        {
            get { return graphs; }
        }

        /// <summary>
        /// Gets the graph pages to be linked from this page.
        /// </summary>
        /// <value>The graph pages.</value>
        public IEnumerable<PeerGraphPageConfiguration> GraphPages
        {
            get { return graphPages; }
        }

        protected override IEnumerable<Object> Items
        {
            get
            {
                var items = new List<object> {ConfigName};

                if (ShowDefault || (!ShowDefault && Frequency != DefaultFrequency))
                    items.Add(Frequency);

                if (ShowDefault || (!ShowDefault && InitialRun != DefaultInitialRun))
                    items.Add(InitialRun);

                if (ShowDefault || (!ShowDefault && FixedRun != DefaultFixedRun))
                    items.Add(FixedRun);

                if (ShowDefault || (!ShowDefault && Theme.ToLower() != DefaultTheme.ToLower()))
                    items.Add(Theme);

                items.Add(Title);
                items.Add(Graphs);
                items.Add(Destinations);

                if (ShowDefault || (!ShowDefault && Link != DefaultLink))
                    items.Add(Link);

                return items.ToArray();
            }
        }

        /// <summary>
        /// Gets the link related to specified peer.
        /// </summary>
        /// <returns>The link.</returns>
        /// <param name="peerId">Peer identifier.</param>
        public string GetLink(int peerId)
        {
            return WebPath + Link + peerId.ToString(CultureInfo.InvariantCulture) + ".html";
        }

        /// <summary>
        /// Attachs the graph pages.
        /// </summary>
        /// <remarks>
        /// Only use from <see cref="PeerGraphPageConfiguration" />
        /// </remarks>
        /// <param name="page">Page.</param>
        internal void AttachGraphPages(PeerGraphPageConfiguration page)
        {
            graphPages.Add(page);
        }

        public override string ToString()
        {
            var list = new List<string> {ConfigurationKeyword.PeerPages};

            if (ShowDefault || (!ShowDefault && Frequency != DefaultFrequency))
                list.Add(ConfigurationKeyword.Frequency);

            if (ShowDefault || (!ShowDefault && InitialRun != DefaultInitialRun))
                list.Add(ConfigurationKeyword.InitialRun);

            if (ShowDefault || (!ShowDefault && FixedRun != DefaultFixedRun))
                list.Add(ConfigurationKeyword.FixedRun);

            if (ShowDefault || (!ShowDefault && Theme.ToLower() != DefaultTheme.ToLower()))
                list.Add(ConfigurationKeyword.PageTemplate);

            list.Add(ConfigurationKeyword.PageTitle);
            list.Add(GraphSetConfiguration.Identifier);
            list.Add(DirectoryCollection.Identifier);

            if (ShowDefault || (!ShowDefault && Link != DefaultLink))
                list.Add(ConfigurationKeyword.PageLink);

            return ConfigText(list.ToArray(), Items);
        }

        public static PeerPageConfiguration Create(
            HostConfiguration server,
            ConfigurationBlock config,
            IEnumerable<PeerGraphConfiguration> peerGraphs)
        {
            Dictionary<String, String> options = GetOptions(Params, config);

            return new PeerPageConfiguration(
                server,
                GetOptionConfigName(options, ConfigurationKeyword.PeerPages, Identifier, true),
                config.IndentLevel,
                GetOptionInteger(options, ConfigurationKeyword.Frequency, Identifier, false, DefaultFrequency),
                GetOptionBoolean(options, ConfigurationKeyword.InitialRun, Identifier, false, DefaultInitialRun),
                GetOptionBoolean(options, ConfigurationKeyword.FixedRun, Identifier, false, DefaultFixedRun),
                GetOptionString(options, ConfigurationKeyword.PageTemplate, Identifier, false, DefaultTheme),
                GetOptionString(options, ConfigurationKeyword.PageTitle, Identifier, false, String.Empty),
                GraphSetConfiguration.Create(server, peerGraphs, config, Identifier),
                DirectoryCollection.Create(server, config),
                GetOptionString(options, ConfigurationKeyword.PageLink, Identifier, false, null));
        }
    }
}